diff --git a/src/backend/replication/logical/origin.c b/src/backend/replication/logical/origin.c
index 5eaf863e02..0aa468789c 100644
--- a/src/backend/replication/logical/origin.c
+++ b/src/backend/replication/logical/origin.c
@@ -473,7 +473,8 @@ ReplicationOriginShmemInit(void)
 
 		replication_states_ctl->tranche_id = LWTRANCHE_REPLICATION_ORIGIN;
 
-		MemSet(replication_states, 0, ReplicationOriginShmemSize());
+		MemSet(replication_states, 0,
+			   mul_size(max_replication_slots, sizeof(ReplicationState)));
 
 		for (i = 0; i < max_replication_slots; i++)
 			LWLockInitialize(&replication_states[i].lock,
